searchData={"items":[{"type":"module","title":"Rhai.AST","doc":"Compiled AST (abstract syntax tree) of a Rhai script.","ref":"Rhai.AST.html"},{"type":"function","title":"Rhai.AST.clear_functions/1","doc":"Clear all function definitions in the AST.","ref":"Rhai.AST.html#clear_functions/1"},{"type":"function","title":"Rhai.AST.clear_source/1","doc":"Clear the source.","ref":"Rhai.AST.html#clear_source/1"},{"type":"function","title":"Rhai.AST.clear_statements/1","doc":"Clear all statements in the AST, leaving only function definitions.","ref":"Rhai.AST.html#clear_statements/1"},{"type":"function","title":"Rhai.AST.clone_functions_only/1","doc":"Clone the AST’s functions into a new AST. No statements are cloned.","ref":"Rhai.AST.html#clone_functions_only/1"},{"type":"function","title":"Rhai.AST.combine/2","doc":"Combine one AST with another. The second AST is consumed.\n\nStatements in the second AST are simply appended to the end of the first without any processing.\nThus, the return value of the first AST (if using expression-statement syntax) is buried.\nOf course, if the first AST uses a return statement at the end, then the second AST will essentially be dead code.\n\nAll script-defined functions in the second AST overwrite similarly-named functions in the first AST with the same number of parameters.\n\nSee [example](https://docs.rs/rhai/latest/rhai/struct.AST.html#example-2) in the Rhai documentation.","ref":"Rhai.AST.html#combine/2"},{"type":"function","title":"Rhai.AST.empty/0","doc":"Create an empty AST.","ref":"Rhai.AST.html#empty/0"},{"type":"function","title":"Rhai.AST.has_functions?/1","doc":"Does this AST contain script-defined functions?","ref":"Rhai.AST.html#has_functions?/1"},{"type":"function","title":"Rhai.AST.merge/2","doc":"Merge two AST into one. Both AST’s are untouched and a new, merged, version is returned.\n\nStatements in the second AST are simply appended to the end of the first without any processing. \nThus, the return value of the first AST (if using expression-statement syntax) is buried.\nOf course, if the first AST uses a return statement at the end, then the second AST will essentially be dead code.\n\nAll script-defined functions in the second AST overwrite similarly-named functions in the first AST with the same number of parameters.\n\nSee [example](https://docs.rs/rhai/latest/rhai/struct.AST.html#example-1) in the Rhai documentation.","ref":"Rhai.AST.html#merge/2"},{"type":"function","title":"Rhai.AST.set_source/2","doc":"Set the source.","ref":"Rhai.AST.html#set_source/2"},{"type":"function","title":"Rhai.AST.source/1","doc":"Get the source if any.","ref":"Rhai.AST.html#source/1"},{"type":"type","title":"Rhai.AST.t/0","doc":"","ref":"Rhai.AST.html#t:t/0"},{"type":"module","title":"Rhai.Any","doc":"Rhai types","ref":"Rhai.Any.html"},{"type":"type","title":"Rhai.Any.t/0","doc":"","ref":"Rhai.Any.html#t:t/0"},{"type":"module","title":"Rhai.Engine","doc":"Rhai main scripting engine.","ref":"Rhai.Engine.html"},{"type":"function","title":"Rhai.Engine.allow_anonymous_fn?/1","doc":"Is anonymous function allowed? Default is true.\n\nNot available under `no_function`.","ref":"Rhai.Engine.html#allow_anonymous_fn?/1"},{"type":"function","title":"Rhai.Engine.allow_if_expression?/1","doc":"Is if-expression allowed? Default is `true`.","ref":"Rhai.Engine.html#allow_if_expression?/1"},{"type":"function","title":"Rhai.Engine.allow_loop_expressions?/1","doc":"Are loop-expression allowed? Default is `true`.","ref":"Rhai.Engine.html#allow_loop_expressions?/1"},{"type":"function","title":"Rhai.Engine.allow_looping?/1","doc":"Is looping allowed? Default is `true`.","ref":"Rhai.Engine.html#allow_looping?/1"},{"type":"function","title":"Rhai.Engine.allow_shadowing?/1","doc":"Is shadowing allowed? Default is `true`.","ref":"Rhai.Engine.html#allow_shadowing?/1"},{"type":"function","title":"Rhai.Engine.allow_statement_expression?/1","doc":"Is statement_expression allowed? Default is `true`.","ref":"Rhai.Engine.html#allow_statement_expression?/1"},{"type":"function","title":"Rhai.Engine.allow_switch_expression?/1","doc":"Is `switch` expression allowed? Default is `true`.","ref":"Rhai.Engine.html#allow_switch_expression?/1"},{"type":"function","title":"Rhai.Engine.call_fn/5","doc":"Call a script function defined in an AST with multiple arguments.","ref":"Rhai.Engine.html#call_fn/5"},{"type":"function","title":"Rhai.Engine.compact_script/2","doc":"Compact a script to eliminate insignificant whitespaces and comments.\nThis is useful to prepare a script for further compressing.\nThe output script is semantically identical to the input script, except smaller in size.\nUnlike other uglifiers and minifiers, this method does not rename variables nor perform any optimization on the input script.","ref":"Rhai.Engine.html#compact_script/2"},{"type":"function","title":"Rhai.Engine.compile/2","doc":"Compile a string into an AST, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile/2"},{"type":"function","title":"Rhai.Engine.compile_expression/2","doc":"Compile a string containing an expression into an AST, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile_expression/2"},{"type":"function","title":"Rhai.Engine.compile_expression_with_scope/3","doc":"Compile a string containing an expression into an AST using own scope, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile_expression_with_scope/3"},{"type":"function","title":"Rhai.Engine.compile_file/2","doc":"Compile a script file into an AST, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile_file/2"},{"type":"function","title":"Rhai.Engine.compile_file_with_scope/3","doc":"Compile a script file into an AST using own scope, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile_file_with_scope/3"},{"type":"function","title":"Rhai.Engine.compile_into_self_contained/3","doc":"Compile a string into an AST using own scope, which can be used later for evaluation, embedding all imported modules.\nModules referred by import statements containing literal string paths are eagerly resolved via the current module resolver and embedded into the resultant AST. When it is evaluated later, import statement directly recall pre-resolved modules and the resolution process is not performed again.","ref":"Rhai.Engine.html#compile_into_self_contained/3"},{"type":"function","title":"Rhai.Engine.compile_scripts_with_scope/3","doc":"When passed a list of strings, first join the strings into one large script, and then compile them into an AST using own scope, which can be used later for evaluation.\n\nThe scope is useful for passing constants into the script for optimization when using `:full` optimization level.","ref":"Rhai.Engine.html#compile_scripts_with_scope/3"},{"type":"function","title":"Rhai.Engine.compile_with_scope/3","doc":"Compile a string into an AST using own scope, which can be used later for evaluation.\n\nConstants Propagation:\nIf not `optimization_level = :none`, constants defined within the scope are propagated throughout the script including functions.\nThis allows functions to be optimized based on dynamic global constants.","ref":"Rhai.Engine.html#compile_with_scope/3"},{"type":"function","title":"Rhai.Engine.disable_symbol/2","doc":"Disable a particular keyword or operator in the language.","ref":"Rhai.Engine.html#disable_symbol/2"},{"type":"function","title":"Rhai.Engine.ensure_data_size_within_limits/2","doc":"Return an error if the size of a Dynamic is out of limits (if any).","ref":"Rhai.Engine.html#ensure_data_size_within_limits/2"},{"type":"function","title":"Rhai.Engine.eval/2","doc":"Evaluate a string as a script, returning the result value or an error.","ref":"Rhai.Engine.html#eval/2"},{"type":"function","title":"Rhai.Engine.eval_ast/2","doc":"Evaluate an AST, returning the result value or an error.","ref":"Rhai.Engine.html#eval_ast/2"},{"type":"function","title":"Rhai.Engine.eval_ast_with_scope/3","doc":"Evaluate an AST with own scope, returning the result value or an error.","ref":"Rhai.Engine.html#eval_ast_with_scope/3"},{"type":"function","title":"Rhai.Engine.eval_expression/2","doc":"Evaluate a string containing an expression, returning the result value or an error.","ref":"Rhai.Engine.html#eval_expression/2"},{"type":"function","title":"Rhai.Engine.eval_expression_with_scope/3","doc":"Evaluate a string containing an expression with own scope, returning the result value or an error.","ref":"Rhai.Engine.html#eval_expression_with_scope/3"},{"type":"function","title":"Rhai.Engine.eval_file/2","doc":"Evaluate a script file, returning the result value or an error.","ref":"Rhai.Engine.html#eval_file/2"},{"type":"function","title":"Rhai.Engine.eval_file_with_scope/3","doc":"Evaluate a script file with own scope, returning the result value or an error.","ref":"Rhai.Engine.html#eval_file_with_scope/3"},{"type":"function","title":"Rhai.Engine.eval_with_scope/3","doc":"Evaluate a string as a script with own scope, returning the result value or an error.","ref":"Rhai.Engine.html#eval_with_scope/3"},{"type":"function","title":"Rhai.Engine.fail_on_invalid_map_property?/1","doc":"Set whether to raise error if an object map property does not exist.","ref":"Rhai.Engine.html#fail_on_invalid_map_property?/1"},{"type":"function","title":"Rhai.Engine.fast_operators?/1","doc":"Is fast operators mode enabled? Default is `false`.","ref":"Rhai.Engine.html#fast_operators?/1"},{"type":"function","title":"Rhai.Engine.max_array_size/1","doc":"The maximum length of arrays (0 for unlimited).\n\nZero under `no_index`.","ref":"Rhai.Engine.html#max_array_size/1"},{"type":"function","title":"Rhai.Engine.max_call_levels/1","doc":"Is fast operators mode enabled? Default is `false`.","ref":"Rhai.Engine.html#max_call_levels/1"},{"type":"function","title":"Rhai.Engine.max_expr_depth/1","doc":"The depth limit for expressions (0 for unlimited).","ref":"Rhai.Engine.html#max_expr_depth/1"},{"type":"function","title":"Rhai.Engine.max_function_expr_depth/1","doc":"The depth limit for expressions in functions (0 for unlimited).\n\nZero under `no_function`.","ref":"Rhai.Engine.html#max_function_expr_depth/1"},{"type":"function","title":"Rhai.Engine.max_map_size/1","doc":"The maximum size of object maps (0 for unlimited).\n\nZero under `no_object`.","ref":"Rhai.Engine.html#max_map_size/1"},{"type":"function","title":"Rhai.Engine.max_modules/1","doc":"The maximum number of imported modules allowed for a script.\n\nZero under `no_module`.","ref":"Rhai.Engine.html#max_modules/1"},{"type":"function","title":"Rhai.Engine.max_operations/1","doc":"The maximum number of operations allowed for a script to run (0 for unlimited).\n\nNot available under `unchecked`.","ref":"Rhai.Engine.html#max_operations/1"},{"type":"function","title":"Rhai.Engine.max_string_size/1","doc":"The maximum length, in bytes, of strings (0 for unlimited).","ref":"Rhai.Engine.html#max_string_size/1"},{"type":"function","title":"Rhai.Engine.new/0","doc":"Create a new Engine","ref":"Rhai.Engine.html#new/0"},{"type":"function","title":"Rhai.Engine.new_raw/0","doc":"Create a new Engine with minimal built-in functions.","ref":"Rhai.Engine.html#new_raw/0"},{"type":"function","title":"Rhai.Engine.optimization_level/1","doc":"The current optimization level. It controls whether and how the Engine will optimize an AST after compilation.","ref":"Rhai.Engine.html#optimization_level/1"},{"type":"function","title":"Rhai.Engine.optimize_ast/4","doc":"Optimize the AST with constants defined in an external Scope.\nAn optimized copy of the AST is returned while the original AST is consumed.\n\nAlthough optimization is performed by default during compilation, sometimes it is necessary to re-optimize an AST.\nFor example, when working with constants that are passed in via an external scope,\nit will be more efficient to optimize the AST once again to take advantage of the new constants.\nWith this method, it is no longer necessary to recompile a large script. The script AST can be compiled just once.\nBefore evaluation, constants are passed into the Engine via an external scope (i.e. with Rhai.Scope.push_constant/2).\nThen, the AST is cloned and the copy re-optimized before running.","ref":"Rhai.Engine.html#optimize_ast/4"},{"type":"function","title":"Rhai.Engine.register_custom_operator/3","doc":"Register a custom operator with a precedence into the language.\n\nThe operator can be a valid identifier, a reserved symbol, a disabled operator or a disabled keyword.\nThe precedence cannot be zero.","ref":"Rhai.Engine.html#register_custom_operator/3"},{"type":"function","title":"Rhai.Engine.register_custom_operator!/3","doc":"Register a custom operator with a precedence into the language.\n\nThe operator can be a valid identifier, a reserved symbol, a disabled operator or a disabled keyword.\nThe precedence cannot be zero.\n\nRaises if the operator cannot be registered.","ref":"Rhai.Engine.html#register_custom_operator!/3"},{"type":"function","title":"Rhai.Engine.register_global_module/2","doc":"Register a shared dylib Module into the global namespace of Engine.\n\nAll functions and type iterators are automatically available to scripts without namespace qualifications.\nSub-modules and variables are ignored.\nWhen searching for functions, modules loaded later are preferred. In other words, loaded modules are searched in reverse order.\n\nReturns an error if the module cannot be loaded.","ref":"Rhai.Engine.html#register_global_module/2"},{"type":"function","title":"Rhai.Engine.register_global_module!/2","doc":"Register a shared dylib Module into the global namespace of Engine.\n\nAll functions and type iterators are automatically available to scripts without namespace qualifications.\nSub-modules and variables are ignored.\nWhen searching for functions, modules loaded later are preferred. In other words, loaded modules are searched in reverse order.\n\nRaises an error if the module cannot be loaded.","ref":"Rhai.Engine.html#register_global_module!/2"},{"type":"function","title":"Rhai.Engine.register_package/2","doc":"Register the package with an Engine.","ref":"Rhai.Engine.html#register_package/2"},{"type":"function","title":"Rhai.Engine.register_static_module/3","doc":"Register a shared Module into the namespace of Engine.\n  \nReturns an error if the module cannot be loaded.","ref":"Rhai.Engine.html#register_static_module/3"},{"type":"function","title":"Rhai.Engine.register_static_module!/3","doc":"Register a shared Module into the namespace of Engine.\n\nRaises an error if the module cannot be loaded.","ref":"Rhai.Engine.html#register_static_module!/3"},{"type":"function","title":"Rhai.Engine.run/2","doc":"Evaluate a string as script.","ref":"Rhai.Engine.html#run/2"},{"type":"function","title":"Rhai.Engine.run_ast/2","doc":"Evaluate an AST.","ref":"Rhai.Engine.html#run_ast/2"},{"type":"function","title":"Rhai.Engine.run_ast_with_scope/3","doc":"Evaluate an AST with own scope.","ref":"Rhai.Engine.html#run_ast_with_scope/3"},{"type":"function","title":"Rhai.Engine.run_file/2","doc":"Evaluate a file.","ref":"Rhai.Engine.html#run_file/2"},{"type":"function","title":"Rhai.Engine.run_file_with_scope/3","doc":"Evaluate a file with own scope.\n\nConstants Propagation\nIf the optimization_level is not `:none` constants defined within the scope are propagated throughout the script including functions.\nThis allows functions to be optimized based on dynamic global constants.","ref":"Rhai.Engine.html#run_file_with_scope/3"},{"type":"function","title":"Rhai.Engine.run_with_scope/3","doc":"Evaluate a string as script with own scope.\n\nConstants Propagation\nIf the optimization_level is not `:none` constants defined within the scope are propagated throughout the script including functions.\nThis allows functions to be optimized based on dynamic global constants.","ref":"Rhai.Engine.html#run_with_scope/3"},{"type":"function","title":"Rhai.Engine.set_allow_anonymous_fn/2","doc":"Set whether anonymous function is allowed.\n\nNot available under `no_function`.","ref":"Rhai.Engine.html#set_allow_anonymous_fn/2"},{"type":"function","title":"Rhai.Engine.set_allow_if_expression/2","doc":"Set whether `if`-expression is allowed.","ref":"Rhai.Engine.html#set_allow_if_expression/2"},{"type":"function","title":"Rhai.Engine.set_allow_loop_expressions/2","doc":"Set whether loop expressions are allowed.","ref":"Rhai.Engine.html#set_allow_loop_expressions/2"},{"type":"function","title":"Rhai.Engine.set_allow_looping/2","doc":"Set whether looping is allowed.","ref":"Rhai.Engine.html#set_allow_looping/2"},{"type":"function","title":"Rhai.Engine.set_allow_shadowing/2","doc":"Set whether shadowing is allowed.","ref":"Rhai.Engine.html#set_allow_shadowing/2"},{"type":"function","title":"Rhai.Engine.set_allow_statement_expression/2","doc":"Set whether statement_expression is allowed.","ref":"Rhai.Engine.html#set_allow_statement_expression/2"},{"type":"function","title":"Rhai.Engine.set_allow_switch_expression/2","doc":"Set whether `switch` expression is allowed.","ref":"Rhai.Engine.html#set_allow_switch_expression/2"},{"type":"function","title":"Rhai.Engine.set_fail_on_invalid_map_property/2","doc":"Set whether to raise error if an object map property does not exist.","ref":"Rhai.Engine.html#set_fail_on_invalid_map_property/2"},{"type":"function","title":"Rhai.Engine.set_fast_operators/2","doc":"Set whether fast operators mode is enabled.","ref":"Rhai.Engine.html#set_fast_operators/2"},{"type":"function","title":"Rhai.Engine.set_max_array_size/2","doc":"Set the maximum length of arrays (0 for unlimited).\n\nNot available under `unchecked` or `no_index`.","ref":"Rhai.Engine.html#set_max_array_size/2"},{"type":"function","title":"Rhai.Engine.set_max_call_levels/2","doc":"Set the maximum levels of function calls allowed for a script in order to avoid infinite recursion and stack overflows.\n\nNot available under `unchecked` or `no_function`.","ref":"Rhai.Engine.html#set_max_call_levels/2"},{"type":"function","title":"Rhai.Engine.set_max_expr_depths/3","doc":"Set the depth limits for expressions (0 for unlimited).\n\nNot available under `unchecked`.","ref":"Rhai.Engine.html#set_max_expr_depths/3"},{"type":"function","title":"Rhai.Engine.set_max_map_size/2","doc":"Set the maximum size of object maps (0 for unlimited).\n\nNot available under `unchecked` or `no_object`.","ref":"Rhai.Engine.html#set_max_map_size/2"},{"type":"function","title":"Rhai.Engine.set_max_modules/2","doc":"Set the maximum number of imported modules allowed for a script.\n\nNot available under `unchecked` or `no_module`.","ref":"Rhai.Engine.html#set_max_modules/2"},{"type":"function","title":"Rhai.Engine.set_max_operations/2","doc":"Set the maximum number of operations allowed for a script to run to avoid consuming too much resources (0 for unlimited).\n\nNot available under `unchecked`.","ref":"Rhai.Engine.html#set_max_operations/2"},{"type":"function","title":"Rhai.Engine.set_max_string_size/2","doc":"Set the maximum length, in bytes, of strings (0 for unlimited).\n\nNot available under `unchecked`.","ref":"Rhai.Engine.html#set_max_string_size/2"},{"type":"function","title":"Rhai.Engine.set_module_resolvers/2","doc":"Set the module resolution services used by the Engine.\n\nThis library supports `:file` and `:dylib` module resolvers.","ref":"Rhai.Engine.html#set_module_resolvers/2"},{"type":"function","title":"Rhai.Engine.set_optimization_level/2","doc":"Control whether and how the Engine will optimize an AST after compilation.","ref":"Rhai.Engine.html#set_optimization_level/2"},{"type":"function","title":"Rhai.Engine.set_strict_variables/2","doc":"Set whether strict variables mode is enabled.","ref":"Rhai.Engine.html#set_strict_variables/2"},{"type":"function","title":"Rhai.Engine.strict_variables?/1","doc":"Is strict variables mode enabled? Default is `false`.","ref":"Rhai.Engine.html#strict_variables?/1"},{"type":"type","title":"Rhai.Engine.t/0","doc":"","ref":"Rhai.Engine.html#t:t/0"},{"type":"module","title":"Rhai.Error","doc":"Rhai error types","ref":"Rhai.Error.html"},{"type":"type","title":"Rhai.Error.error/0","doc":"","ref":"Rhai.Error.html#t:error/0"},{"type":"type","title":"Rhai.Error.t/0","doc":"","ref":"Rhai.Error.html#t:t/0"},{"type":"module","title":"Rhai.Package","doc":"Rhai package types","ref":"Rhai.Package.html"},{"type":"type","title":"Rhai.Package.t/0","doc":"","ref":"Rhai.Package.html#t:t/0"},{"type":"module","title":"Rhai.Scope","doc":"Type containing information about the current scope. Useful for keeping state between Engine evaluation runs.\nScope implements the [https://hexdocs.pm/elixir/1.12/Enumerable.html](Enumerable) protocol.","ref":"Rhai.Scope.html"},{"type":"function","title":"Rhai.Scope.clear/1","doc":"Empty the Scope.","ref":"Rhai.Scope.html#clear/1"},{"type":"function","title":"Rhai.Scope.clone_visible/1","doc":"Clone the Scope, keeping only the last instances of each variable name. Shadowed variables are omitted in the copy.","ref":"Rhai.Scope.html#clone_visible/1"},{"type":"function","title":"Rhai.Scope.constant?/2","doc":"Check if the named entry in the Scope is constant.\nSearch starts backwards from the last, stopping at the first entry matching the specified name.\nReturns nil if no entry matching the specified name is found.","ref":"Rhai.Scope.html#constant?/2"},{"type":"function","title":"Rhai.Scope.contains?/2","doc":"Does the Scope contain the entry?","ref":"Rhai.Scope.html#contains?/2"},{"type":"function","title":"Rhai.Scope.empty?/1","doc":"Returns true if this Scope contains no variables.","ref":"Rhai.Scope.html#empty?/1"},{"type":"function","title":"Rhai.Scope.get_value/2","doc":"Get the value of an entry in the Scope, starting from the last.","ref":"Rhai.Scope.html#get_value/2"},{"type":"function","title":"Rhai.Scope.len/1","doc":"Get the number of entries inside the Scope.","ref":"Rhai.Scope.html#len/1"},{"type":"function","title":"Rhai.Scope.new/0","doc":"Create a new Scope","ref":"Rhai.Scope.html#new/0"},{"type":"function","title":"Rhai.Scope.pop/1","doc":"Remove the last entry from the Scope.\n\nReturns an error if the Scope is empty.","ref":"Rhai.Scope.html#pop/1"},{"type":"function","title":"Rhai.Scope.pop!/1","doc":"Remove the last entry from the Scope.\n\nRaises if the Scope is empty.","ref":"Rhai.Scope.html#pop!/1"},{"type":"function","title":"Rhai.Scope.push/3","doc":"Add (push) a new entry to the Scope.","ref":"Rhai.Scope.html#push/3"},{"type":"function","title":"Rhai.Scope.push_constant/3","doc":"Add (push) a new constant to the Scope.\n\nConstants are immutable and cannot be assigned to. Their values never change.\nConstants propagation is a technique used to optimize an AST.","ref":"Rhai.Scope.html#push_constant/3"},{"type":"function","title":"Rhai.Scope.remove/2","doc":"Remove the last entry in the Scope by the specified name and return its value.\n\nIf the entry by the specified name is not found, None is returned.","ref":"Rhai.Scope.html#remove/2"},{"type":"function","title":"Rhai.Scope.rewind/2","doc":"Truncate (rewind) the Scope to a previous size.","ref":"Rhai.Scope.html#rewind/2"},{"type":"function","title":"Rhai.Scope.set_or_push/3","doc":"Update the value of the named entry in the Scope if it already exists and is not constant.\nPush a new entry with the value into the Scope if the name doesn’t exist or if the existing entry is constant.\n\nSearch starts backwards from the last, and only the first entry matching the specified name is updated.","ref":"Rhai.Scope.html#set_or_push/3"},{"type":"function","title":"Rhai.Scope.set_value/3","doc":"Update the value of the named entry in the Scope.\n\nSearch starts backwards from the last, and only the first entry matching the specified name is updated.\nIf no entry matching the specified name is found, a new one is added.\n\nReturns an error when trying to update the value of a constant.","ref":"Rhai.Scope.html#set_value/3"},{"type":"function","title":"Rhai.Scope.set_value!/3","doc":"Update the value of the named entry in the Scope.\n\nSearch starts backwards from the last, and only the first entry matching the specified name is updated.\nIf no entry matching the specified name is found, a new one is added.\n\nRaises when trying to update the value of a constant.","ref":"Rhai.Scope.html#set_value!/3"},{"type":"type","title":"Rhai.Scope.t/0","doc":"","ref":"Rhai.Scope.html#t:t/0"},{"type":"function","title":"Rhai.Scope.with_capacity/1","doc":"Create a new Scope with a particular capacity.","ref":"Rhai.Scope.html#with_capacity/1"},{"type":"extras","title":"rhai_rustler","doc":"# rhai_rustler\n\n[![CI](https://github.com/rhaiscript/rhai_rustler/actions/workflows/main.yaml/badge.svg)](https://github.com/rhaiscript/rhai_rustler/actions/workflows/main.yaml)\n[![Rust CI](https://github.com/rhaiscript/rhai_rustler/actions/workflows/rust-ci.yaml/badge.svg)](https://github.com/rhaiscript/rhai_rustler/actions/workflows/rust-ci.yaml)\n[![NIFs precompilation](https://github.com/rhaiscript/rhai_rustler/actions/workflows/release.yaml/badge.svg)](https://github.com/rhaiscript/rhai_rustler/actions/workflows/release.yaml)\n[![Hex.pm](https://img.shields.io/hexpm/v/rhai_rustler.svg)](https://hex.pm/packages/rhai_rustler)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-purple.svg)](https://hexdocs.pm/rhai_rustler/)\n\nElixir NIF bindings for Rhai, a tiny, simple and fast embedded scripting language for Rust that gives you a safe and easy way to add scripting to your applications.\n\nPlease refer to [The Rhai Book](https://rhai.rs/book/index.html) for extended information about the language.","ref":"readme.html"},{"type":"extras","title":"Installation - rhai_rustler","doc":"Add `:rhai_rustler` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:rhai_rustler, \"~> 1.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Features - rhai_rustler","doc":"`rhai_rustler` exposes a subset of the Rhai API to Elixir:\n\n- [Engine]() - [Rhai Book](https://rhai.rs/book/engine/index.html) - [docs.rs](https://docs.rs/rhai/latest/rhai/struct.Engine.html)\n- [Scope]() - [Rhai book](https://rhai.rs/book/engine/scope.html) - [docs.rs](https://docs.rs/rhai/latest/rhai/struct.Scope.html)\n- [AST]() - [Rhai book](https://rhai.rs/book/engine/ast.html) - [docs.rs](https://docs.rs/rhai/latest/rhai/struct.Ast.html)\n\nNote that not all the Rhai API features are supported. For instance, advanced and low-level APIs are not exposed.\n\nIf any usage patterns become apparent, they will be included in the future.\n\nPlease refer to [NIF bindings](guides/nif-bindings.md) to see the methods supported by the Elixir NIF.\n\nThe Elixir NIF provides a way to extend Rhai with external native Rust modules, see: [Extending Rhai with external native Rust modules](#extending-rhai-with-external-native-rust-modules) and [rhai_dylib](https://github.com/rhaiscript/rhai-dylib) for more information.\n\nTo check the supported types conversion, see [Type conversion table](#type-conversion-table).","ref":"readme.html#features"},{"type":"extras","title":"Usage patterns - rhai_rustler","doc":"### \"Hello Rhai\"\n\n```elixir\nengine = Rhai.Engine.new()\n\n{:ok, \"Hello Rhai!\"} = Rhai.Engine.eval(engine, \"\\\"Hello Rhai!\\\"\")\n```","ref":"readme.html#usage-patterns"},{"type":"extras","title":"Eval - rhai_rustler","doc":"```elixir\nengine = Rhai.Engine.new()\n\n# Simple evaluation\n{:ok, 2} = Rhai.Engine.eval(engine, \"1 + 1\")\n\n# Evaluation with scope\nscope = Rhai.Scope.new() |> Rhai.Scope.push(\"a\", 10) |> Rhai.Scope.push(\"b\", 3)\n{:ok, 30} = Rhai.Engine.eval_with_scope(engine, scope, \"a * b\")\n```","ref":"readme.html#eval"},{"type":"extras","title":"AST - rhai_rustler","doc":"```elixir\nengine = Rhai.Engine.new()\nscope = Rhai.Scope.new() |> Rhai.Scope.push_constant(\"a\", 10) |> Rhai.Scope.push_constant(\"b\", 3)\n\n{:ok, %Rhai.AST{} = ast} = Rhai.Engine.compile_with_scope(engine, scope, \"a * b\")\n{:ok, 30} = Rhai.Engine.eval_ast(engine, ast)\n\n# AST can be shared between engines\ntask = Task.async(fn -> Rhai.Engine.eval_ast(Rhai.Engine.new(), ast) end)\n{:ok, 30} = Task.await(task)\n```","ref":"readme.html#ast"},{"type":"extras","title":"Raw Engine - rhai_rustler","doc":"```elixir\nengine = Rhai.Engine.new_raw()\n\n# Returns an error since BasicArrayPackage is not registered\n{:error, {:function_not_found, _}} = Rhai.Engine.eval(engine, \"[1, 2, 3].find(|x| x > 2)\")\n\n# Please refer to https://rhai.rs/book/rust/packages/builtin.html for more information about packages\nengine = Rhai.Engine.register_package(engine, :basic_array)\n{:ok, 3} = Rhai.Engine.eval(engine, \"[1, 2, 3].find(|x| x > 2)\")\n```","ref":"readme.html#raw-engine"},{"type":"extras","title":"Extending rhai_rustler with external native Rust modules - rhai_rustler","doc":"`rhai_rustler` utilizes the `[rhai_dylib](https://github.com/rhaiscript/rhai-dylib)` library to expand the capabilities of Rhai by loading external native Rust modules. This allows users to introduce new functions, custom types, and operators.\n\n[test_dylib_module](https://github.com/rhaiscript/rhai_rustler/tree/main/native/test_dylib_module) serves as an example of how to create a dylib module. A [dummy rustler module](https://github.com/rhaiscript/rhai_rustler/blob/main/test/support/test_dylib_module.ex) is employed to trigger the compilation process. This same approach can be adopted in real-world projects, such as when distributing the dylib module as a Hex package.","ref":"readme.html#extending-rhai_rustler-with-external-native-rust-modules"},{"type":"extras","title":"Type conversion table - rhai_rustler","doc":"Elixir Types are converted to Rhai types (and back) as follows:\n\n| Elixir                          | Rhai                  |\n| ------------------------------- | --------------------- |\n| integer()                       | Integer               |\n| float()                         | Float                 |\n| float()                         | Decimal               |\n| bool()                          | Boolean               |\n| String.t()                      | String                |\n| String.t()                      | Char                  |\n| list()                          | Array                 |\n| tuple()                         | Array                 |\n| %{ String.t() => Rhai.Any.t() } | Object map            |\n| nil()                           | Empty                 |\n| pid()                           | Empty (not supported) |\n| ref()                           | Empty (not supported) |\n| fun()                           | Empty (not supported) |\n| map()                           | Empty (not supported) |","ref":"readme.html#type-conversion-table"},{"type":"extras","title":"Rustler precompiled - rhai_rustler","doc":"By default, **you don't need the Rust toolchain installed** because the lib will try to download\na precompiled NIF file.\nIn case you want to force compilation set the\n`RHAI_RUSTLER_FORCE_BUILD` environment variable to `true` or `1`.\n\nPrecompiled NIFs are available for the following platforms:\n\n- aarch64-apple-darwin\n- x86_64-apple-darwin\n- x86_64-unknown-linux-gnu\n- x86_64-unknown-linux-musl\n- arm-unknown-linux-gnueabihf\n- aarch64-unknown-linux-gnu\n- aarch64-unknown-linux-musl\n- x86_64-pc-windows-msvc\n- x86_64-pc-windows-gnu","ref":"readme.html#rustler-precompiled"},{"type":"extras","title":"Release flow - rhai_rustler","doc":"Please follow [this guide](https://hexdocs.pm/rustler_precompiled/precompilation_guide.html#the-release-flow) when releasing a new version of the library.","ref":"readme.html#release-flow"},{"type":"extras","title":"License - rhai_rustler","doc":"This library is licensed under Apache 2.0 License. See [LICENSE](LICENSE) for details.","ref":"readme.html#license"},{"type":"extras","title":"Links - rhai_rustler","doc":"- [rhai](https://github.com/rhaiscript/rhai) The Rust crate doing most of the dirty work.\n- [RustlerPrecompiled](https://github.com/philss/rustler_precompiled) Use precompiled NIFs from trusted sources in your Elixir code.\n- [NimbleLZ4](https://github.com/whatyouhide/nimble_lz4) Major inspiration for the RustlerPrecompiled GitHub actions workflow and general setup.","ref":"readme.html#links"},{"type":"extras","title":"NIF Bindings","doc":"# NIF Bindings","ref":"nif-bindings.html"},{"type":"extras","title":"Engine - NIF Bindings","doc":"| Rust                                                                                                                                      | Elixir                                                                                                                    | Notes                                                                                                                      |\n| ----------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------- |\n| [allow_anonymous_fn](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.allow_anonymous_fn)                                       | [allow_anonymous_fn/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#allow_anonymous_fn/1)                             |                                                                                                                            |\n| [allow_if_expression](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.allow_if_expression)                                     | [allow_if_expression/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#allow_if_expression/1)                           |                                                                                                                            |\n| [allow_loop_expressions](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.allow_loop_expressions)                               | [allow_loop_expressions/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#allow_loop_expressions/1)                     |                                                                                                                            |\n| [allow_looping](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.allow_looping)                                                 | [allow_looping/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#allow_looping/1)                                       |                                                                                                                            |\n| [allow_shadowing](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.allow_shadowing)                                             | [allow_shadowing/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#allow_shadowing/1)                                   |                                                                                                                            |\n| [allow_statement_expression](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.allow_statement_expression)                       | [allow_statement_expression/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#allow_statement_expression/1)             |                                                                                                                            |\n| [allow_switch_expression](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.allow_switch_expression)                             | [allow_switch_expression/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#allow_switch_expression/1)                   |                                                                                                                            |\n| [build_type](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.build_type)                                                       | -                                                                                                                         | use [dylib](../README.md#extending-rhai-rustler-with-external-native-rust-modules) instead                                 |\n| [call_fn](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.call_fn)                                                             | [call_fn/4](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#call_fn/4)                                                   |                                                                                                                            |\n| [call_fn_dynamic](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.call_fn_dynamic)                                             | -                                                                                                                         | deprecated                                                                                                                 |\n| [call_fn_raw](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.call_fn_raw)                                                     | -                                                                                                                         | deprecated                                                                                                                 |\n| [call_fn_with_options](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.call_fn_with_options)                                   | -                                                                                                                         | advanced API                                                                                                               |\n| [compact_script](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compact_script)                                               | [compact_script/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compact_script/2)                                     |                                                                                                                            |\n| [compile](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compile)                                                             | [compile/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compile/2)                                                   |                                                                                                                            |\n| [compile_expression](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compile_expression)                                       | [compile_expression/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compile_expression/2)                             |                                                                                                                            |\n| [compile_expression_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compile_expression_with_scope)                 | [compile_expression_with_scope/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compile_expression_with_scope/2)       |                                                                                                                            |\n| [compile_file](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compile_file)                                                   | [compile_file/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compile_file/2)                                         |                                                                                                                            |\n| [compile_file_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compile_file_with_scope)                             | [compile_file_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compile_file_with_scope/3)                   |                                                                                                                            |\n| [compile_into_self_contained](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compile_into_self_contained)                     | [compile_into_self_contained/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compile_into_self_contained/3)           |                                                                                                                            |\n| [compile_scripts_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compile_scripts_with_scope)                       | [compile_scripts_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compile_scripts_with_scope/3)             |                                                                                                                            |\n| [compile_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.compile_with_scope)                                       | [compile_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#compile_with_scope/3)                             |                                                                                                                            |\n| [const_empty_string](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.const_empty_string)                                       | -                                                                                                                         | not implemented                                                                                                            |\n| [consume](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.consume)                                                             | -                                                                                                                         | deprecated, use `run` instead                                                                                              |\n| [consume_ast](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.consume_ast)                                                     | -                                                                                                                         | deprecated                                                                                                                 |\n| [consume_ast_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.consume_ast_with_scope)                               | -                                                                                                                         | deprecated                                                                                                                 |\n| [consume_file](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.consume_file)                                                   | -                                                                                                                         | deprecated                                                                                                                 |\n| [consume_file_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.consume_file_with_scope)                             | -                                                                                                                         | deprecated                                                                                                                 |\n| [consume_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.consume_with_scope)                                       | -                                                                                                                         | deprecated                                                                                                                 |\n| [default_tag](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.default_tag)                                                     | -                                                                                                                         | not implemented                                                                                                            |\n| [default_tag_mut](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.default_tag_mut)                                             | -                                                                                                                         | not implemented                                                                                                            |\n| [definitions](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.definitions)                                                     | -                                                                                                                         | internals                                                                                                                  |\n| [definitions_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.definitions_with_scope)                               | -                                                                                                                         | internals                                                                                                                  |\n| [disable_symbol](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.disable_symbol)                                               | -                                                                                                                         |                                                                                                                            |\n| [ensure_data_size_within_limits](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.ensure_data_size_within_limits)               | [ensure_data_size_within_limits/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#ensure_data_size_within_limits/2)     |                                                                                                                            |\n| [eval](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval)                                                                   | [eval/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#eval/2)                                                         |                                                                                                                            |\n| [eval_ast](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval_ast)                                                           | [eval_ast/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#eval_ast/2)                                                 |                                                                                                                            |\n| [eval_ast_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval_ast_with_scope)                                     | [eval_ast_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#eval_ast_with_scope/3)                           |                                                                                                                            |\n| [eval_expression](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval_expression)                                             | [eval_expression/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#eval_expression/2)                                   |                                                                                                                            |\n| [eval_expression_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval_expression_with_scope)                       | [eval_expression_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#eval_expression_with_scope/3)             |                                                                                                                            |\n| [eval_file](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval_file)                                                         | [eval_file/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#eval_file/2)                                               |                                                                                                                            |\n| [eval_file_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval_file_with_scope)                                   | [eval_file_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#eval_file_with_scope/3)                         |                                                                                                                            |\n| [eval_statements_raw](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval_statements_raw)                                     | -                                                                                                                         | deprecated                                                                                                                 |\n| [eval_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.eval_with_scope)                                             | [eval_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#eval_with_scope/3)                                   |                                                                                                                            |\n| [fail_on_invalid_map_property](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.fail_on_invalid_map_property)                   | [fail_on_invalid_map_property/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#fail_on_invalid_map_property/1)         |                                                                                                                            |\n| [fast_operators](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.fast_operators)                                               | [fast_operators/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#fast_operators/1)                                     |                                                                                                                            |\n| [gen_fn_metadata_to_json](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.gen_fn_metadata_to_json)                             | -                                                                                                                         | not implemented, metadata feature is not enabled                                                                           |\n| [gen_fn_metadata_with_ast_to_json](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.gen_fn_metadata_with_ast_to_json)           | -                                                                                                                         | not implemented, metadata feature is not enabled                                                                           |\n| [gen_fn_signatures](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.gen_fn_signatures)                                         | -                                                                                                                         | not implemented, metadata feature is not enabled                                                                           |\n| [get_interned_string](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.get_interned_string)                                     | -                                                                                                                         | internals                                                                                                                  |\n| [lex](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.lex)                                                                     | -                                                                                                                         | internals                                                                                                                  |\n| [lex_with_map](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.lex_with_map)                                                   | -                                                                                                                         | internals                                                                                                                  |\n| [map_type_name](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.map_type_name)                                                 | -                                                                                                                         | not implemented                                                                                                            |\n| [max_array_size](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.max_array_size)                                               | [max_array_size/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#max_array_size/1)                                     |                                                                                                                            |\n| [max_call_levels](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.max_call_levels)                                             | [max_call_levels/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#max_call_levels/1)                                   |                                                                                                                            |\n| [max_expr_depth](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.max_expr_depth)                                               | [max_expr_depth/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#max_expr_depth/1)                                     |                                                                                                                            |\n| [max_function_expr_depth](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.max_function_expr_depth)                             | [max_function_expr_depth/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#max_function_expr_depth/1)                   |                                                                                                                            |\n| [max_map_size](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.max_map_size)                                                   | [max_map_size/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#max_map_size/1)                                         |                                                                                                                            |\n| [max_modules](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.max_modules)                                                     | [max_modules/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#max_modules/1)                                           |                                                                                                                            |\n| [max_operations](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.max_operations)                                               | [max_operations/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#max_operations/1)                                     |                                                                                                                            |\n| [max_string_size](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.max_string_size)                                             | [max_string_size/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#max_string_size/1)                                   |                                                                                                                            |\n| [new](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.new)                                                                     | [new/0](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#new/0)                                                           |                                                                                                                            |\n| [new_raw](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.new_raw)                                                             | [new_raw/0](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#new_raw/0)                                                   |                                                                                                                            |\n| [optimization_level](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.optimization_level)                                       | [optimization_level/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#optimization_level/1)                             |                                                                                                                            |\n| [optimize_ast](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.optimize_ast)                                                   | [optimize_ast/4](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#optimize_ast/4)                                         |                                                                                                                            |\n| [register_custom_operator](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_custom_operator)                           | [register_custom_operator/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#register_custom_operator/3)                 | use [dylib](../README.md#extending-rhai-rustler-with-external-native-rust-modules) instead                                 |\n| [register_global_module](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_global_module)                               | [register_global_module/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#register_global_module/2)                     |                                                                                                                            |\n| [register_indexer_get](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_indexer_get)                                   | -                                                                                                                         | use [dylib](../README.md#extending-rhai-rustler-with-external-native-rust-modules) instead                                 |\n| [register_custom_syntax](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_custom_syntax)                               | -                                                                                                                         | use [dylib](../README.md#extending-rhai-rustler-with-external-native-rust-modules) instead                                 |\n| [register_custom_syntax_raw](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_custom_syntax_raw)                       | -                                                                                                                         | deprecated                                                                                                                 |\n| [register_custom_syntax_with_state_raw](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_custom_syntax_with_state_raw) | -                                                                                                                         | low level API                                                                                                              |\n| [register_debugger](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_debugger)                                         | -                                                                                                                         | unstable                                                                                                                   |\n| [register_fn](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_fn)                                                     | -                                                                                                                         | use [dylib](../README.md#extending-rhai-rustler-with-external-native-rust-modules) instead                                 |\n| [register_get](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_get)                                                   | -                                                                                                                         | use [dylib](../README.md#extending-rhai-rustler-with-external-native-rust-modules) instead                                 |\n| [register_get_result](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_get_result)                                     | -                                                                                                                         | deprecated                                                                                                                 |\n| [register_get_set](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.register_get_set)                                           | -                                                                                                                         | use [dylib](../README.md#extending-rhai-rustler-with-external-native-rust-modules) instead                                 |\n| [run](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.run)                                                                     | [run/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#run/2)                                                           |                                                                                                                            |\n| [run_ast](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.run_ast)                                                             | [run_ast/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#run_ast/2)                                                   |                                                                                                                            |\n| [run_ast_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.run_ast_with_scope)                                       | [run_ast_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#run_ast_with_scope/3)                             |                                                                                                                            |\n| [run_file](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.run_file)                                                           | [run_file/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#run_file/2)                                                 |                                                                                                                            |\n| [run_file_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.run_file_with_scope)                                     | [run_file_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#run_file_with_scope/3)                           |                                                                                                                            |\n| [run_with_scope](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.run_with_scope)                                               | [run_with_scope/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#run_with_scope/3)                                     |                                                                                                                            |\n| [set_allow_anonymous_fn](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_allow_anonymous_fn)                               | [set_allow_anonymous_fn/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_allow_anonymous_fn/2)                     |                                                                                                                            |\n| [set_allow_if_expression](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_allow_if_expression)                             | [set_allow_if_expression/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_allow_if_expression/2)                   |                                                                                                                            |\n| [set_allow_loop_expressions](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_allow_loop_expressions)                       | [set_allow_loop_expressions/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_allow_loop_expressions/2)             |                                                                                                                            |\n| [set_allow_looping](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_allow_looping)                                         | [set_allow_looping/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_allow_looping/2)                               |                                                                                                                            |\n| [set_allow_shadowing](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_allow_shadowing)                                     | [set_allow_shadowing/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_allow_shadowing/2)                           |                                                                                                                            |\n| [set_allow_statement_expression](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_allow_statement_expression)               | [set_allow_statement_expression/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_allow_statement_expression/2)     |                                                                                                                            |\n| [set_allow_switch_expression](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_allow_switch_expression)                     | [set_allow_switch_expression/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_allow_switch_expression/2)           |                                                                                                                            |\n| [set_default_tag](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_default_tag)                                             | -                                                                                                                         | not implemented                                                                                                            |\n| [set_fail_on_invalid_map_property](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_fail_on_invalid_map_property)           | [set_fail_on_invalid_map_property/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_fail_on_invalid_map_property/2) |                                                                                                                            |\n| [set_fast_operators](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_fast_operators)                                       | [set_fast_operators/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_fast_operators/2)                             |                                                                                                                            |\n| [set_max_array_size](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_max_array_size)                                       | [set_max_array_size/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_max_array_size/2)                             |                                                                                                                            |\n| [set_max_call_levels](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_max_call_levels)                                     | [set_max_call_levels/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_max_call_levels/2)                           |                                                                                                                            |\n| [set_max_expr_depths](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_max_expr_depths)                                     | [set_max_expr_depths/3](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_max_expr_depths/3)                           |                                                                                                                            |\n| [set_max_map_size](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_max_map_size)                                           | [set_max_map_size/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_max_map_size/2)                                 |                                                                                                                            |\n| [set_max_modules](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_max_modules)                                             | [set_max_modules/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_max_modules/2)                                   |                                                                                                                            |\n| [set_max_operations](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_max_operations)                                       | [set_max_operations/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_max_operations/2)                             |                                                                                                                            |\n| [set_max_string_size](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_max_string_size)                                     | [set_max_string_size/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_max_string_size/2)                           |                                                                                                                            |\n| [set_module_resolver](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_module_resolver)                                     | [set_module_resolvers/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_module_resolvers/2)                         | sets a [ModuleResolverCollection](https://docs.rs/rhai/latest/rhai/module_resolvers/struct.ModuleResolversCollection.html) |\n| [set_optimization_level](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_optimization_level)                               | [set_optimization_level/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_optimization_level/2)                     |                                                                                                                            |\n| [set_strict_variables](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.set_strict_variables)                                   | [set_strict_variables/2](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#set_strict_variables/2)                         |                                                                                                                            |\n| [strict_variables](https://docs.rs/rhai/latest/rhai/struct.Engine.html#method.strict_variables)                                           | [strict_variables/1](https://hexdocs.pm/rhai_rustler/Rhai.Engine.html#strict_variables/1)                                 |                                                                                                                            |","ref":"nif-bindings.html#engine"},{"type":"extras","title":"Scope - NIF Bindings","doc":"| Rust                                                                                                     | Elixir                                                                             | Notes                                                                                                     |\n| -------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------- |\n| [clear](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.clear)                                 | [clear/1](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#clear/1)                 |                                                                                                           |\n| [clone_visible](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.clone_visible)                 | [clone_visible/1](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#clone_visible/1) |                                                                                                           |\n| [contains](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.contains)                           | [contains/2](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#contains/2)           |                                                                                                           |\n| [get](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.get)                                     | -                                                                                  | not implemented, use `get_value`                                                                          |\n| [get_mut](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.get_mut)                             | -                                                                                  | not implemented, use `get_value`                                                                          |\n| [get_value](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.get_value)                         | [get_value/2](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#get_value/2)         |                                                                                                           |\n| [is_constant](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.is_constant)                     | [is_constant/2](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#is_constant/2)     |                                                                                                           |\n| [is_empty](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.is_empty)                           | [is_empty/1](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#is_empty/1)           |                                                                                                           |\n| [iter](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.iter)                                   | -                                                                                  | note implemented, `Scope` implements the [Enumerable](https://hexdocs.pm/elixir/Enumerable.html) protocol |\n| [iter_raw](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.iter_raw)                           | -                                                                                  | not implemented                                                                                           |\n| [len](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.len)                                     | [len/1](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#len/1)                     |                                                                                                           |\n| [new](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.new)                                     | [new/0](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#new/0)                     |                                                                                                           |\n| [pop](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.pop)                                     | [pop/1](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#pop/1)                     |                                                                                                           |\n| [push](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.push)                                   | [push/2](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#push/2)                   |                                                                                                           |\n| [push_constant](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.push_constant)                 | [push_constant/2](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#push_constant/2) |                                                                                                           |\n| [push_constant_dynamic](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.push_constant_dynamic) | -                                                                                  | not implemented, use `push_constant`                                                                      |\n| [push_dynamic](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.push_dynamic)                   | -                                                                                  | not implemented, use `push`                                                                               |\n| [remove](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.remove)                               | [remove/2](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#remove/2)               |                                                                                                           |\n| [rewind](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.rewind)                               | [rewind/2](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#rewind/2)               |                                                                                                           |\n| [set_alias](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.set_alias)                         | [set_alias/3](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#set_alias/3)         |                                                                                                           |\n| [set_or_push](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.set_or_push)                     | [set_or_push/3](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#set_or_push/3)     |                                                                                                           |\n| [set_value](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.set_value)                         | [set_value/3](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#set_value/3)         |                                                                                                           |\n| [with_capacity](https://docs.rs/rhai/latest/rhai/struct.Scope.html#method.with_capacity)                 | [with_capacity/1](https://hexdocs.pm/rhai_rustler/Rhai.Scope.html#with_capacity/1) |                                                                                                           |","ref":"nif-bindings.html#scope"},{"type":"extras","title":"AST - NIF Bindings","doc":"| Rust                                                                                                                   | Elixir                                                                                           | Notes                                                     |\n| ---------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------ | --------------------------------------------------------- |\n| [clear_doc](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.clear_doc)                                         | -                                                                                                | not implemented, metadata feature is not enabled          |\n| [clear_functions](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.clear_functions)                             | [clear_functions/1](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#clear_functions/1)             |                                                           |\n| [clear_source](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.clear_source)                                   | [clear_source/1](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#clear_source/1)                   |                                                           |\n| [clear_statements](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.clear_statements)                           | [clear_statements/1](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#clear_statements/1)           |                                                           |\n| [clone_functions_only](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.clone_functions_only)                   | [clone_functions_only/1](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#clone_functions_only/1)   |                                                           |\n| [clone_functions_only_filtered](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.clone_functions_only_filtered) | -                                                                                                | calling an Elixir function is not supported at the moment |\n| [clone_statements_only](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.clone_statements_only)                 | [clone_statements_only/1](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#clone_statements_only/1) |                                                           |\n| [combine](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.combine)                                             | [combine/2](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#combine/2)                             |                                                           |\n| [combine_filtered](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.combine_filtered)                           | -                                                                                                | calling an Elixir function is not supported at the moment |\n| [doc](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.doc)                                                     | -                                                                                                | not implemented, metadata feature is not enabled          |\n| [empty](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.empty)                                                 | [empty/0](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#empty/0)                                 |                                                           |\n| [has_functions](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.has_functions)                                 | [has_functions/1](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#has_functions/1)                 |                                                           |\n| [iter_fn_def](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.iter_fn_def)                                     | -                                                                                                | internals                                                 |\n| [iter_functions](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.iter_functions)                               | -                                                                                                |                                                           |\n| [iter_literal_variables](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.iter_literal_variables)               | -                                                                                                |                                                           |\n| [lib](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.lib)                                                     | -                                                                                                | deprecated                                                |\n| [merge](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.merge)                                                 | [merge/2](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#merge/2)                                 |                                                           |\n| [merge_filtered](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.merge_filtered)                               | -                                                                                                | calling an Elixir function is not supported at the moment |\n| [new](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.new)                                                     | -                                                                                                | internals                                                 |\n| [new_with_source](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.new_with_source)                             | -                                                                                                | internals                                                 |\n| [resolver](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.resolver)                                           | -                                                                                                | internals                                                 |\n| [retain_functions](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.retain_functions)                           | -                                                                                                | calling an Elixir function is not supported at the moment |\n| [set_source](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.set_source)                                       | [set_source/2](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#set_source/2)                       |                                                           |\n| [shared_lib](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.shared_lib)                                       | -                                                                                                | internals                                                 |\n| [source](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.source)                                               | [source/0](https://hexdocs.pm/rhai_rustler/Rhai.AST.html#source/0)                               |                                                           |\n| [statements](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.statements)                                       | -                                                                                                | internals                                                 |\n| [walk](https://docs.rs/rhai/latest/rhai/struct.AST.html#method.walk)                                                   | -                                                                                                | internals                                                 |","ref":"nif-bindings.html#ast"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}