searchNodes=[{"doc":"Compiled AST (abstract syntax tree) of a Rhai script.","ref":"Rhai.AST.html","title":"Rhai.AST","type":"module"},{"doc":"Clear all function definitions in the AST.","ref":"Rhai.AST.html#clear_functions/1","title":"Rhai.AST.clear_functions/1","type":"function"},{"doc":"Clear the source.","ref":"Rhai.AST.html#clear_source/1","title":"Rhai.AST.clear_source/1","type":"function"},{"doc":"Clear all statements in the AST, leaving only function definitions.","ref":"Rhai.AST.html#clear_statements/1","title":"Rhai.AST.clear_statements/1","type":"function"},{"doc":"Clone the AST’s functions into a new AST. No statements are cloned.","ref":"Rhai.AST.html#clone_functions_only/1","title":"Rhai.AST.clone_functions_only/1","type":"function"},{"doc":"Combine one AST with another. The second AST is consumed. Statements in the second AST are simply appended to the end of the first without any processing. Thus, the return value of the first AST (if using expression-statement syntax) is buried. Of course, if the first AST uses a return statement at the end, then the second AST will essentially be dead code. All script-defined functions in the second AST overwrite similarly-named functions in the first AST with the same number of parameters. See example in the Rhai documentation.","ref":"Rhai.AST.html#combine/2","title":"Rhai.AST.combine/2","type":"function"},{"doc":"Create an empty AST.","ref":"Rhai.AST.html#empty/0","title":"Rhai.AST.empty/0","type":"function"},{"doc":"Does this AST contain script-defined functions?","ref":"Rhai.AST.html#has_functions?/1","title":"Rhai.AST.has_functions?/1","type":"function"},{"doc":"Merge two AST into one. Both AST’s are untouched and a new, merged, version is returned. Statements in the second AST are simply appended to the end of the first without any processing. Thus, the return value of the first AST (if using expression-statement syntax) is buried. Of course, if the first AST uses a return statement at the end, then the second AST will essentially be dead code. All script-defined functions in the second AST overwrite similarly-named functions in the first AST with the same number of parameters. See example in the Rhai documentation.","ref":"Rhai.AST.html#merge/2","title":"Rhai.AST.merge/2","type":"function"},{"doc":"Set the source.","ref":"Rhai.AST.html#set_source/2","title":"Rhai.AST.set_source/2","type":"function"},{"doc":"Get the source if any.","ref":"Rhai.AST.html#source/1","title":"Rhai.AST.source/1","type":"function"},{"doc":"","ref":"Rhai.AST.html#t:t/0","title":"Rhai.AST.t/0","type":"type"},{"doc":"Rhai types","ref":"Rhai.Any.html","title":"Rhai.Any","type":"module"},{"doc":"","ref":"Rhai.Any.html#t:t/0","title":"Rhai.Any.t/0","type":"type"},{"doc":"Rhai main scripting engine.","ref":"Rhai.Engine.html","title":"Rhai.Engine","type":"module"},{"doc":"Is anonymous function allowed? Default is true. Not available under no_function .","ref":"Rhai.Engine.html#allow_anonymous_fn?/1","title":"Rhai.Engine.allow_anonymous_fn?/1","type":"function"},{"doc":"Is if-expression allowed? Default is true .","ref":"Rhai.Engine.html#allow_if_expression?/1","title":"Rhai.Engine.allow_if_expression?/1","type":"function"},{"doc":"Are loop-expression allowed? Default is true .","ref":"Rhai.Engine.html#allow_loop_expressions?/1","title":"Rhai.Engine.allow_loop_expressions?/1","type":"function"},{"doc":"Is looping allowed? Default is true .","ref":"Rhai.Engine.html#allow_looping?/1","title":"Rhai.Engine.allow_looping?/1","type":"function"},{"doc":"Is shadowing allowed? Default is true .","ref":"Rhai.Engine.html#allow_shadowing?/1","title":"Rhai.Engine.allow_shadowing?/1","type":"function"},{"doc":"Is statement_expression allowed? Default is true .","ref":"Rhai.Engine.html#allow_statement_expression?/1","title":"Rhai.Engine.allow_statement_expression?/1","type":"function"},{"doc":"Is switch expression allowed? Default is true .","ref":"Rhai.Engine.html#allow_switch_expression?/1","title":"Rhai.Engine.allow_switch_expression?/1","type":"function"},{"doc":"Call a script function defined in an AST with multiple arguments.","ref":"Rhai.Engine.html#call_fn/5","title":"Rhai.Engine.call_fn/5","type":"function"},{"doc":"Compact a script to eliminate insignificant whitespaces and comments. This is useful to prepare a script for further compressing. The output script is semantically identical to the input script, except smaller in size. Unlike other uglifiers and minifiers, this method does not rename variables nor perform any optimization on the input script.","ref":"Rhai.Engine.html#compact_script/2","title":"Rhai.Engine.compact_script/2","type":"function"},{"doc":"Compile a string into an AST, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile/2","title":"Rhai.Engine.compile/2","type":"function"},{"doc":"Compile a string containing an expression into an AST, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile_expression/2","title":"Rhai.Engine.compile_expression/2","type":"function"},{"doc":"Compile a string containing an expression into an AST using own scope, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile_expression_with_scope/3","title":"Rhai.Engine.compile_expression_with_scope/3","type":"function"},{"doc":"Compile a script file into an AST, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile_file/2","title":"Rhai.Engine.compile_file/2","type":"function"},{"doc":"Compile a script file into an AST using own scope, which can be used later for evaluation.","ref":"Rhai.Engine.html#compile_file_with_scope/3","title":"Rhai.Engine.compile_file_with_scope/3","type":"function"},{"doc":"Compile a string into an AST using own scope, which can be used later for evaluation, embedding all imported modules. Modules referred by import statements containing literal string paths are eagerly resolved via the current module resolver and embedded into the resultant AST. When it is evaluated later, import statement directly recall pre-resolved modules and the resolution process is not performed again.","ref":"Rhai.Engine.html#compile_into_self_contained/3","title":"Rhai.Engine.compile_into_self_contained/3","type":"function"},{"doc":"When passed a list of strings, first join the strings into one large script, and then compile them into an AST using own scope, which can be used later for evaluation. The scope is useful for passing constants into the script for optimization when using :full optimization level.","ref":"Rhai.Engine.html#compile_scripts_with_scope/3","title":"Rhai.Engine.compile_scripts_with_scope/3","type":"function"},{"doc":"Compile a string into an AST using own scope, which can be used later for evaluation. Constants Propagation: If not optimization_level = :none , constants defined within the scope are propagated throughout the script including functions. This allows functions to be optimized based on dynamic global constants.","ref":"Rhai.Engine.html#compile_with_scope/3","title":"Rhai.Engine.compile_with_scope/3","type":"function"},{"doc":"Disable a particular keyword or operator in the language.","ref":"Rhai.Engine.html#disable_symbol/2","title":"Rhai.Engine.disable_symbol/2","type":"function"},{"doc":"Return an error if the size of a Dynamic is out of limits (if any).","ref":"Rhai.Engine.html#ensure_data_size_within_limits/2","title":"Rhai.Engine.ensure_data_size_within_limits/2","type":"function"},{"doc":"Evaluate a string as a script, returning the result value or an error.","ref":"Rhai.Engine.html#eval/2","title":"Rhai.Engine.eval/2","type":"function"},{"doc":"Evaluate an AST, returning the result value or an error.","ref":"Rhai.Engine.html#eval_ast/2","title":"Rhai.Engine.eval_ast/2","type":"function"},{"doc":"Evaluate an AST with own scope, returning the result value or an error.","ref":"Rhai.Engine.html#eval_ast_with_scope/3","title":"Rhai.Engine.eval_ast_with_scope/3","type":"function"},{"doc":"Evaluate a string containing an expression, returning the result value or an error.","ref":"Rhai.Engine.html#eval_expression/2","title":"Rhai.Engine.eval_expression/2","type":"function"},{"doc":"Evaluate a string containing an expression with own scope, returning the result value or an error.","ref":"Rhai.Engine.html#eval_expression_with_scope/3","title":"Rhai.Engine.eval_expression_with_scope/3","type":"function"},{"doc":"Evaluate a script file, returning the result value or an error.","ref":"Rhai.Engine.html#eval_file/2","title":"Rhai.Engine.eval_file/2","type":"function"},{"doc":"Evaluate a script file with own scope, returning the result value or an error.","ref":"Rhai.Engine.html#eval_file_with_scope/3","title":"Rhai.Engine.eval_file_with_scope/3","type":"function"},{"doc":"Evaluate a string as a script with own scope, returning the result value or an error.","ref":"Rhai.Engine.html#eval_with_scope/3","title":"Rhai.Engine.eval_with_scope/3","type":"function"},{"doc":"Set whether to raise error if an object map property does not exist.","ref":"Rhai.Engine.html#fail_on_invalid_map_property?/1","title":"Rhai.Engine.fail_on_invalid_map_property?/1","type":"function"},{"doc":"Is fast operators mode enabled? Default is false .","ref":"Rhai.Engine.html#fast_operators?/1","title":"Rhai.Engine.fast_operators?/1","type":"function"},{"doc":"The maximum length of arrays (0 for unlimited). Zero under no_index .","ref":"Rhai.Engine.html#max_array_size/1","title":"Rhai.Engine.max_array_size/1","type":"function"},{"doc":"Is fast operators mode enabled? Default is false .","ref":"Rhai.Engine.html#max_call_levels/1","title":"Rhai.Engine.max_call_levels/1","type":"function"},{"doc":"The depth limit for expressions (0 for unlimited).","ref":"Rhai.Engine.html#max_expr_depth/1","title":"Rhai.Engine.max_expr_depth/1","type":"function"},{"doc":"The depth limit for expressions in functions (0 for unlimited). Zero under no_function .","ref":"Rhai.Engine.html#max_function_expr_depth/1","title":"Rhai.Engine.max_function_expr_depth/1","type":"function"},{"doc":"The maximum size of object maps (0 for unlimited). Zero under no_object .","ref":"Rhai.Engine.html#max_map_size/1","title":"Rhai.Engine.max_map_size/1","type":"function"},{"doc":"The maximum number of imported modules allowed for a script. Zero under no_module .","ref":"Rhai.Engine.html#max_modules/1","title":"Rhai.Engine.max_modules/1","type":"function"},{"doc":"The maximum number of operations allowed for a script to run (0 for unlimited). Not available under unchecked .","ref":"Rhai.Engine.html#max_operations/1","title":"Rhai.Engine.max_operations/1","type":"function"},{"doc":"The maximum length, in bytes, of strings (0 for unlimited).","ref":"Rhai.Engine.html#max_string_size/1","title":"Rhai.Engine.max_string_size/1","type":"function"},{"doc":"Create a new Engine","ref":"Rhai.Engine.html#new/0","title":"Rhai.Engine.new/0","type":"function"},{"doc":"Create a new Engine with minimal built-in functions.","ref":"Rhai.Engine.html#new_raw/0","title":"Rhai.Engine.new_raw/0","type":"function"},{"doc":"The current optimization level. It controls whether and how the Engine will optimize an AST after compilation.","ref":"Rhai.Engine.html#optimization_level/1","title":"Rhai.Engine.optimization_level/1","type":"function"},{"doc":"Optimize the AST with constants defined in an external Scope. An optimized copy of the AST is returned while the original AST is consumed. Although optimization is performed by default during compilation, sometimes it is necessary to re-optimize an AST. For example, when working with constants that are passed in via an external scope, it will be more efficient to optimize the AST once again to take advantage of the new constants. With this method, it is no longer necessary to recompile a large script. The script AST can be compiled just once. Before evaluation, constants are passed into the Engine via an external scope (i.e. with Rhai.Scope.push_constant/2). Then, the AST is cloned and the copy re-optimized before running.","ref":"Rhai.Engine.html#optimize_ast/4","title":"Rhai.Engine.optimize_ast/4","type":"function"},{"doc":"Register a custom operator with a precedence into the language. The operator can be a valid identifier, a reserved symbol, a disabled operator or a disabled keyword. The precedence cannot be zero.","ref":"Rhai.Engine.html#register_custom_operator/3","title":"Rhai.Engine.register_custom_operator/3","type":"function"},{"doc":"Register a custom operator with a precedence into the language. The operator can be a valid identifier, a reserved symbol, a disabled operator or a disabled keyword. The precedence cannot be zero. Raises if the operator cannot be registered.","ref":"Rhai.Engine.html#register_custom_operator!/3","title":"Rhai.Engine.register_custom_operator!/3","type":"function"},{"doc":"Register a shared dylib Module into the global namespace of Engine. All functions and type iterators are automatically available to scripts without namespace qualifications. Sub-modules and variables are ignored. When searching for functions, modules loaded later are preferred. In other words, loaded modules are searched in reverse order. Returns an error if the module cannot be loaded.","ref":"Rhai.Engine.html#register_global_module/2","title":"Rhai.Engine.register_global_module/2","type":"function"},{"doc":"Register a shared dylib Module into the global namespace of Engine. All functions and type iterators are automatically available to scripts without namespace qualifications. Sub-modules and variables are ignored. When searching for functions, modules loaded later are preferred. In other words, loaded modules are searched in reverse order. Raises an error if the module cannot be loaded.","ref":"Rhai.Engine.html#register_global_module!/2","title":"Rhai.Engine.register_global_module!/2","type":"function"},{"doc":"Register the package with an Engine.","ref":"Rhai.Engine.html#register_package/2","title":"Rhai.Engine.register_package/2","type":"function"},{"doc":"Register a shared Module into the namespace of Engine. Returns an error if the module cannot be loaded.","ref":"Rhai.Engine.html#register_static_module/3","title":"Rhai.Engine.register_static_module/3","type":"function"},{"doc":"Register a shared Module into the namespace of Engine. Raises an error if the module cannot be loaded.","ref":"Rhai.Engine.html#register_static_module!/3","title":"Rhai.Engine.register_static_module!/3","type":"function"},{"doc":"Evaluate a string as script.","ref":"Rhai.Engine.html#run/2","title":"Rhai.Engine.run/2","type":"function"},{"doc":"Evaluate an AST.","ref":"Rhai.Engine.html#run_ast/2","title":"Rhai.Engine.run_ast/2","type":"function"},{"doc":"Evaluate an AST with own scope.","ref":"Rhai.Engine.html#run_ast_with_scope/3","title":"Rhai.Engine.run_ast_with_scope/3","type":"function"},{"doc":"Evaluate a file.","ref":"Rhai.Engine.html#run_file/2","title":"Rhai.Engine.run_file/2","type":"function"},{"doc":"Evaluate a file with own scope. Constants Propagation If the optimization_level is not :none constants defined within the scope are propagated throughout the script including functions. This allows functions to be optimized based on dynamic global constants.","ref":"Rhai.Engine.html#run_file_with_scope/3","title":"Rhai.Engine.run_file_with_scope/3","type":"function"},{"doc":"Evaluate a string as script with own scope. Constants Propagation If the optimization_level is not :none constants defined within the scope are propagated throughout the script including functions. This allows functions to be optimized based on dynamic global constants.","ref":"Rhai.Engine.html#run_with_scope/3","title":"Rhai.Engine.run_with_scope/3","type":"function"},{"doc":"Set whether anonymous function is allowed. Not available under no_function .","ref":"Rhai.Engine.html#set_allow_anonymous_fn/2","title":"Rhai.Engine.set_allow_anonymous_fn/2","type":"function"},{"doc":"Set whether if -expression is allowed.","ref":"Rhai.Engine.html#set_allow_if_expression/2","title":"Rhai.Engine.set_allow_if_expression/2","type":"function"},{"doc":"Set whether loop expressions are allowed.","ref":"Rhai.Engine.html#set_allow_loop_expressions/2","title":"Rhai.Engine.set_allow_loop_expressions/2","type":"function"},{"doc":"Set whether looping is allowed.","ref":"Rhai.Engine.html#set_allow_looping/2","title":"Rhai.Engine.set_allow_looping/2","type":"function"},{"doc":"Set whether shadowing is allowed.","ref":"Rhai.Engine.html#set_allow_shadowing/2","title":"Rhai.Engine.set_allow_shadowing/2","type":"function"},{"doc":"Set whether statement_expression is allowed.","ref":"Rhai.Engine.html#set_allow_statement_expression/2","title":"Rhai.Engine.set_allow_statement_expression/2","type":"function"},{"doc":"Set whether switch expression is allowed.","ref":"Rhai.Engine.html#set_allow_switch_expression/2","title":"Rhai.Engine.set_allow_switch_expression/2","type":"function"},{"doc":"Set whether to raise error if an object map property does not exist.","ref":"Rhai.Engine.html#set_fail_on_invalid_map_property/2","title":"Rhai.Engine.set_fail_on_invalid_map_property/2","type":"function"},{"doc":"Set whether fast operators mode is enabled.","ref":"Rhai.Engine.html#set_fast_operators/2","title":"Rhai.Engine.set_fast_operators/2","type":"function"},{"doc":"Set the maximum length of arrays (0 for unlimited). Not available under unchecked or no_index .","ref":"Rhai.Engine.html#set_max_array_size/2","title":"Rhai.Engine.set_max_array_size/2","type":"function"},{"doc":"Set the maximum levels of function calls allowed for a script in order to avoid infinite recursion and stack overflows. Not available under unchecked or no_function .","ref":"Rhai.Engine.html#set_max_call_levels/2","title":"Rhai.Engine.set_max_call_levels/2","type":"function"},{"doc":"Set the depth limits for expressions (0 for unlimited). Not available under unchecked .","ref":"Rhai.Engine.html#set_max_expr_depths/3","title":"Rhai.Engine.set_max_expr_depths/3","type":"function"},{"doc":"Set the maximum size of object maps (0 for unlimited). Not available under unchecked or no_object .","ref":"Rhai.Engine.html#set_max_map_size/2","title":"Rhai.Engine.set_max_map_size/2","type":"function"},{"doc":"Set the maximum number of imported modules allowed for a script. Not available under unchecked or no_module .","ref":"Rhai.Engine.html#set_max_modules/2","title":"Rhai.Engine.set_max_modules/2","type":"function"},{"doc":"Set the maximum number of operations allowed for a script to run to avoid consuming too much resources (0 for unlimited). Not available under unchecked .","ref":"Rhai.Engine.html#set_max_operations/2","title":"Rhai.Engine.set_max_operations/2","type":"function"},{"doc":"Set the maximum length, in bytes, of strings (0 for unlimited). Not available under unchecked .","ref":"Rhai.Engine.html#set_max_string_size/2","title":"Rhai.Engine.set_max_string_size/2","type":"function"},{"doc":"Set the module resolution services used by the Engine. This library supports :file and :dylib module resolvers.","ref":"Rhai.Engine.html#set_module_resolvers/2","title":"Rhai.Engine.set_module_resolvers/2","type":"function"},{"doc":"Control whether and how the Engine will optimize an AST after compilation.","ref":"Rhai.Engine.html#set_optimization_level/2","title":"Rhai.Engine.set_optimization_level/2","type":"function"},{"doc":"Set whether strict variables mode is enabled.","ref":"Rhai.Engine.html#set_strict_variables/2","title":"Rhai.Engine.set_strict_variables/2","type":"function"},{"doc":"Is strict variables mode enabled? Default is false .","ref":"Rhai.Engine.html#strict_variables?/1","title":"Rhai.Engine.strict_variables?/1","type":"function"},{"doc":"","ref":"Rhai.Engine.html#t:t/0","title":"Rhai.Engine.t/0","type":"type"},{"doc":"Rhai error types","ref":"Rhai.Error.html","title":"Rhai.Error","type":"module"},{"doc":"","ref":"Rhai.Error.html#t:error/0","title":"Rhai.Error.error/0","type":"type"},{"doc":"","ref":"Rhai.Error.html#t:t/0","title":"Rhai.Error.t/0","type":"type"},{"doc":"Rhai package types","ref":"Rhai.Package.html","title":"Rhai.Package","type":"module"},{"doc":"","ref":"Rhai.Package.html#t:t/0","title":"Rhai.Package.t/0","type":"type"},{"doc":"Type containing information about the current scope. Useful for keeping state between Engine evaluation runs. Scope implements the https://hexdocs.pm/elixir/1.12/Enumerable.html protocol.","ref":"Rhai.Scope.html","title":"Rhai.Scope","type":"module"},{"doc":"Empty the Scope.","ref":"Rhai.Scope.html#clear/1","title":"Rhai.Scope.clear/1","type":"function"},{"doc":"Clone the Scope, keeping only the last instances of each variable name. Shadowed variables are omitted in the copy.","ref":"Rhai.Scope.html#clone_visible/1","title":"Rhai.Scope.clone_visible/1","type":"function"},{"doc":"Check if the named entry in the Scope is constant. Search starts backwards from the last, stopping at the first entry matching the specified name. Returns nil if no entry matching the specified name is found.","ref":"Rhai.Scope.html#constant?/2","title":"Rhai.Scope.constant?/2","type":"function"},{"doc":"Does the Scope contain the entry?","ref":"Rhai.Scope.html#contains?/2","title":"Rhai.Scope.contains?/2","type":"function"},{"doc":"Returns true if this Scope contains no variables.","ref":"Rhai.Scope.html#empty?/1","title":"Rhai.Scope.empty?/1","type":"function"},{"doc":"Get the value of an entry in the Scope, starting from the last.","ref":"Rhai.Scope.html#get_value/2","title":"Rhai.Scope.get_value/2","type":"function"},{"doc":"Get the number of entries inside the Scope.","ref":"Rhai.Scope.html#len/1","title":"Rhai.Scope.len/1","type":"function"},{"doc":"Create a new Scope","ref":"Rhai.Scope.html#new/0","title":"Rhai.Scope.new/0","type":"function"},{"doc":"Remove the last entry from the Scope. Returns an error if the Scope is empty.","ref":"Rhai.Scope.html#pop/1","title":"Rhai.Scope.pop/1","type":"function"},{"doc":"Remove the last entry from the Scope. Raises if the Scope is empty.","ref":"Rhai.Scope.html#pop!/1","title":"Rhai.Scope.pop!/1","type":"function"},{"doc":"Add (push) a new entry to the Scope.","ref":"Rhai.Scope.html#push/3","title":"Rhai.Scope.push/3","type":"function"},{"doc":"Add (push) a new constant to the Scope. Constants are immutable and cannot be assigned to. Their values never change. Constants propagation is a technique used to optimize an AST.","ref":"Rhai.Scope.html#push_constant/3","title":"Rhai.Scope.push_constant/3","type":"function"},{"doc":"Remove the last entry in the Scope by the specified name and return its value. If the entry by the specified name is not found, None is returned.","ref":"Rhai.Scope.html#remove/2","title":"Rhai.Scope.remove/2","type":"function"},{"doc":"Truncate (rewind) the Scope to a previous size.","ref":"Rhai.Scope.html#rewind/2","title":"Rhai.Scope.rewind/2","type":"function"},{"doc":"Update the value of the named entry in the Scope if it already exists and is not constant. Push a new entry with the value into the Scope if the name doesn’t exist or if the existing entry is constant. Search starts backwards from the last, and only the first entry matching the specified name is updated.","ref":"Rhai.Scope.html#set_or_push/3","title":"Rhai.Scope.set_or_push/3","type":"function"},{"doc":"Update the value of the named entry in the Scope. Search starts backwards from the last, and only the first entry matching the specified name is updated. If no entry matching the specified name is found, a new one is added. Returns an error when trying to update the value of a constant.","ref":"Rhai.Scope.html#set_value/3","title":"Rhai.Scope.set_value/3","type":"function"},{"doc":"Update the value of the named entry in the Scope. Search starts backwards from the last, and only the first entry matching the specified name is updated. If no entry matching the specified name is found, a new one is added. Raises when trying to update the value of a constant.","ref":"Rhai.Scope.html#set_value!/3","title":"Rhai.Scope.set_value!/3","type":"function"},{"doc":"Create a new Scope with a particular capacity.","ref":"Rhai.Scope.html#with_capacity/1","title":"Rhai.Scope.with_capacity/1","type":"function"},{"doc":"","ref":"Rhai.Scope.html#t:t/0","title":"Rhai.Scope.t/0","type":"type"},{"doc":"Elixir NIF bindings for Rhai, a tiny, simple and fast embedded scripting language for Rust that gives you a safe and easy way to add scripting to your applications. Please refer to The Rhai Book for extended information about the language.","ref":"readme.html","title":"rhai_rustler","type":"extras"},{"doc":"Add :rhai_rustler to the list of dependencies in mix.exs : def deps do [ { :rhai_rustler , &quot;~&gt; 1.0.0&quot; } ] end","ref":"readme.html#installation","title":"rhai_rustler - Installation","type":"extras"},{"doc":"rhai_rustler exposes a subset of the Rhai API to Elixir: Engine - Rhai Book - docs.rs Scope - Rhai book - docs.rs AST - Rhai book - docs.rs Note that not all the Rhai API features are supported. For instance, advanced and low-level APIs are not exposed. If any usage patterns become apparent, they will be included in the future. Please refer to NIF bindings to see the methods supported by the Elixir NIF. The Elixir NIF provides a way to extend Rhai with external native Rust modules, see: Extending Rhai with external native Rust modules and rhai_dylib for more information. To check the supported types conversion, see Type conversion table .","ref":"readme.html#features","title":"rhai_rustler - Features","type":"extras"},{"doc":"&quot;Hello Rhai&quot; engine = Rhai.Engine . new ( ) { :ok , &quot;Hello Rhai!&quot; } = Rhai.Engine . eval ( engine , &quot; \\&quot; Hello Rhai! \\&quot; &quot; ) Eval engine = Rhai.Engine . new ( ) # Simple evaluation { :ok , 2 } = Rhai.Engine . eval ( engine , &quot;1 + 1&quot; ) # Evaluation with scope scope = Rhai.Scope . new ( ) |&gt; Rhai.Scope . push ( &quot;a&quot; , 10 ) |&gt; Rhai.Scope . push ( &quot;b&quot; , 3 ) { :ok , 30 } = Rhai.Engine . eval_with_scope ( engine , scope , &quot;a * b&quot; ) AST engine = Rhai.Engine . new ( ) scope = Rhai.Scope . new ( ) |&gt; Rhai.Scope . push_constant ( &quot;a&quot; , 10 ) |&gt; Rhai.Scope . push_constant ( &quot;b&quot; , 3 ) { :ok , % Rhai.AST { } = ast } = Rhai.Engine . compile_with_scope ( engine , scope , &quot;a * b&quot; ) { :ok , 30 } = Rhai.Engine . eval_ast ( engine , ast ) # AST can be shared between engines task = Task . async ( fn -&gt; Rhai.Engine . eval_ast ( Rhai.Engine . new ( ) , ast ) end ) { :ok , 30 } = Task . await ( task ) Raw Engine engine = Rhai.Engine . new_raw ( ) # Returns an error since BasicArrayPackage is not registered { :error , { :function_not_found , _ } } = Rhai.Engine . eval ( engine , &quot;[1, 2, 3].find(|x| x &gt; 2)&quot; ) # Please refer to https://rhai.rs/book/rust/packages/builtin.html for more information about packages engine = Rhai.Engine . register_package ( engine , :basic_array ) { :ok , 3 } = Rhai.Engine . eval ( engine , &quot;[1, 2, 3].find(|x| x &gt; 2)&quot; ) Extending rhai_rustler with external native Rust modules rhai_rustler utilizes the [rhai_dylib](https://github.com/rhaiscript/rhai-dylib) library to expand the capabilities of Rhai by loading external native Rust modules. This allows users to introduce new functions, custom types, and operators. test_dylib_module serves as an example of how to create a dylib module. A dummy rustler module is employed to trigger the compilation process. This same approach can be adopted in real-world projects, such as when distributing the dylib module as a Hex package.","ref":"readme.html#usage-patterns","title":"rhai_rustler - Usage patterns","type":"extras"},{"doc":"Elixir Types are converted to Rhai types (and back) as follows: Elixir Rhai integer() Integer float() Float float() Decimal bool() Boolean String.t() String String.t() Char list() Array tuple() Array %{ String.t() =&gt; Rhai.Any.t() } Object map nil() Empty pid() Empty (not supported) ref() Empty (not supported) fun() Empty (not supported) map() Empty (not supported)","ref":"readme.html#type-conversion-table","title":"rhai_rustler - Type conversion table","type":"extras"},{"doc":"By default, you don't need the Rust toolchain installed because the lib will try to download a precompiled NIF file. In case you want to force compilation set the RHAI_RUSTLER_FORCE_BUILD environment variable to true or 1 . Precompiled NIFs are available for the following platforms: aarch64-apple-darwin x86_64-apple-darwin x86_64-unknown-linux-gnu x86_64-unknown-linux-musl arm-unknown-linux-gnueabihf aarch64-unknown-linux-gnu aarch64-unknown-linux-musl x86_64-pc-windows-msvc x86_64-pc-windows-gnu Release flow Please follow this guide when releasing a new version of the library.","ref":"readme.html#rustler-precompiled","title":"rhai_rustler - Rustler precompiled","type":"extras"},{"doc":"This library is licensed under Apache 2.0 License. See LICENSE for details.","ref":"readme.html#license","title":"rhai_rustler - License","type":"extras"},{"doc":"rhai The Rust crate doing most of the dirty work. RustlerPrecompiled Use precompiled NIFs from trusted sources in your Elixir code. NimbleLZ4 Major inspiration for the RustlerPrecompiled GitHub actions workflow and general setup.","ref":"readme.html#links","title":"rhai_rustler - Links","type":"extras"},{"doc":"","ref":"nif-bindings.html","title":"NIF Bindings","type":"extras"},{"doc":"Rust Elixir Notes allow_anonymous_fn allow_anonymous_fn/1 allow_if_expression allow_if_expression/1 allow_loop_expressions allow_loop_expressions/1 allow_looping allow_looping/1 allow_shadowing allow_shadowing/1 allow_statement_expression allow_statement_expression/1 allow_switch_expression allow_switch_expression/1 build_type - use dylib instead call_fn call_fn/4 call_fn_dynamic - deprecated call_fn_raw - deprecated call_fn_with_options - advanced API compact_script compact_script/2 compile compile/2 compile_expression compile_expression/2 compile_expression_with_scope compile_expression_with_scope/2 compile_file compile_file/2 compile_file_with_scope compile_file_with_scope/3 compile_into_self_contained compile_into_self_contained/3 compile_scripts_with_scope compile_scripts_with_scope/3 compile_with_scope compile_with_scope/3 const_empty_string - not implemented consume - deprecated, use run instead consume_ast - deprecated consume_ast_with_scope - deprecated consume_file - deprecated consume_file_with_scope - deprecated consume_with_scope - deprecated default_tag - not implemented default_tag_mut - not implemented definitions - internals definitions_with_scope - internals disable_symbol - ensure_data_size_within_limits ensure_data_size_within_limits/2 eval eval/2 eval_ast eval_ast/2 eval_ast_with_scope eval_ast_with_scope/3 eval_expression eval_expression/2 eval_expression_with_scope eval_expression_with_scope/3 eval_file eval_file/2 eval_file_with_scope eval_file_with_scope/3 eval_statements_raw - deprecated eval_with_scope eval_with_scope/3 fail_on_invalid_map_property fail_on_invalid_map_property/1 fast_operators fast_operators/1 gen_fn_metadata_to_json - not implemented, metadata feature is not enabled gen_fn_metadata_with_ast_to_json - not implemented, metadata feature is not enabled gen_fn_signatures - not implemented, metadata feature is not enabled get_interned_string - internals lex - internals lex_with_map - internals map_type_name - not implemented max_array_size max_array_size/1 max_call_levels max_call_levels/1 max_expr_depth max_expr_depth/1 max_function_expr_depth max_function_expr_depth/1 max_map_size max_map_size/1 max_modules max_modules/1 max_operations max_operations/1 max_string_size max_string_size/1 new new/0 new_raw new_raw/0 optimization_level optimization_level/1 optimize_ast optimize_ast/4 register_custom_operator register_custom_operator/3 use dylib instead register_global_module register_global_module/2 register_indexer_get - use dylib instead register_custom_syntax - use dylib instead register_custom_syntax_raw - deprecated register_custom_syntax_with_state_raw - low level API register_debugger - unstable register_fn - use dylib instead register_get - use dylib instead register_get_result - deprecated register_get_set - use dylib instead run run/2 run_ast run_ast/2 run_ast_with_scope run_ast_with_scope/3 run_file run_file/2 run_file_with_scope run_file_with_scope/3 run_with_scope run_with_scope/3 set_allow_anonymous_fn set_allow_anonymous_fn/2 set_allow_if_expression set_allow_if_expression/2 set_allow_loop_expressions set_allow_loop_expressions/2 set_allow_looping set_allow_looping/2 set_allow_shadowing set_allow_shadowing/2 set_allow_statement_expression set_allow_statement_expression/2 set_allow_switch_expression set_allow_switch_expression/2 set_default_tag - not implemented set_fail_on_invalid_map_property set_fail_on_invalid_map_property/2 set_fast_operators set_fast_operators/2 set_max_array_size set_max_array_size/2 set_max_call_levels set_max_call_levels/2 set_max_expr_depths set_max_expr_depths/3 set_max_map_size set_max_map_size/2 set_max_modules set_max_modules/2 set_max_operations set_max_operations/2 set_max_string_size set_max_string_size/2 set_module_resolver set_module_resolvers/2 sets a ModuleResolverCollection set_optimization_level set_optimization_level/2 set_strict_variables set_strict_variables/2 strict_variables strict_variables/1","ref":"nif-bindings.html#engine","title":"NIF Bindings - Engine","type":"extras"},{"doc":"Rust Elixir Notes clear clear/1 clone_visible clone_visible/1 contains contains/2 get - not implemented, use get_value get_mut - not implemented, use get_value get_value get_value/2 is_constant is_constant/2 is_empty is_empty/1 iter - note implemented, Scope implements the Enumerable protocol iter_raw - not implemented len len/1 new new/0 pop pop/1 push push/2 push_constant push_constant/2 push_constant_dynamic - not implemented, use push_constant push_dynamic - not implemented, use push remove remove/2 rewind rewind/2 set_alias set_alias/3 set_or_push set_or_push/3 set_value set_value/3 with_capacity with_capacity/1","ref":"nif-bindings.html#scope","title":"NIF Bindings - Scope","type":"extras"},{"doc":"Rust Elixir Notes clear_doc - not implemented, metadata feature is not enabled clear_functions clear_functions/1 clear_source clear_source/1 clear_statements clear_statements/1 clone_functions_only clone_functions_only/1 clone_functions_only_filtered - calling an Elixir function is not supported at the moment clone_statements_only clone_statements_only/1 combine combine/2 combine_filtered - calling an Elixir function is not supported at the moment doc - not implemented, metadata feature is not enabled empty empty/0 has_functions has_functions/1 iter_fn_def - internals iter_functions - iter_literal_variables - lib - deprecated merge merge/2 merge_filtered - calling an Elixir function is not supported at the moment new - internals new_with_source - internals resolver - internals retain_functions - calling an Elixir function is not supported at the moment set_source set_source/2 shared_lib - internals source source/0 statements - internals walk - internals","ref":"nif-bindings.html#ast","title":"NIF Bindings - AST","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]